 program
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

include('traywnd.inc') !include before the map

Msgs               FILE,DRIVER('TOPSPEED'),PRE(msgs),BINDABLE,CREATE,THREAD
kMsgID                KEY(msgs:msgId),NOCASE,OPT,PRIMARY
Record                   RECORD,PRE()
msgId                      LONG
cfrom                      cstring(40)
cMsg                       cstring(400)
                         END
                     END                       


 map
   main() !frame
   tester() !starts tray popups for testing
   showmsg(string strMsgID)!started when the tray window is double clicked
 end
LoadFileError byte(0)
 code
 main()

!this is the app frame purely for testing
main procedure()
AppFrame APPLICATION('Test tray popups'),STATUS,SYSTEM,RESIZE
       MENUBAR
         MENU('&File'),USE(?File)
           ITEM('E&xit'),USE(?FileExit)
         END
       END
     END

  code

  open(appframe)
  display()
  accept
    case event()
    of event:openwindow
      !load test messages into the msg file
      do loadfile
      if loadfileerror then post(event:closewindow);cycle.


      !this is the thread that starts the tray popups - a tray popup factory!
      start(popupstarter,,address(showMsg))

      !this is the user interface for starting tray popups just for testing
      start(tester)

    end
  end
  close(msgs)
  close(appframe)
  return

!load the msgs file with dummy messages.
loadfile routine
      clear(loadfileerror)
      create(msgs)
      if errorcode() then message('create failed: ' & error());LoadFileError=True;exit.
      open(msgs,42H)
      if errorcode() then message('open failed: ' & error());LoadFileError=True;exit.
      msgs.cfrom='Jim Kane'
      msgs.msgid=1
      msgs.cmsg='Don''t you want to use spiffy popup windows in your app or do you want to look old and dos like forever resulting in a loss of sales?'
      add(msgs)
      if errorcode() then message('add failed: ' &error());LoadFileError=True;exit.
      msgs.cfrom='Alan'
      msgs.msgid=2
      msgs.cmsg='Is the project done yet.'
      add(msgs)
      if errorcode() then message('add failed: ' &error());LoadFileError=True;exit.
      exit



!this is the user interface to start a popup message
tester procedure()
window WINDOW('Test Tray Popups'),AT(,,145,43),SYSTEM,GRAY,DOUBLE,MDI
       BUTTON('Record 1'),AT(21,22,45,14),USE(?Button1)
       BUTTON('Record 2'),AT(79,22,45,14),USE(?Button2)
     END
  code
  open(msgs,42H)
  if errorcode() then message('fileopen error: ' &error());return.
  open(window)
  display()
  accept
    case event()
    of event:accepted
      case field()
      of ?button1
        msgs.msgid=1
        get(msgs,msgs:kMsgID)
        if ~errorcode() then
          trayWndQLock.EnterCriticalSection()
            TrayWndQ.cFrom=msgs.cfrom
            traywndq.cMsg=msgs.cmsg
            traywndq.msgid=msgs.msgid
            add(traywndq,1)
          trayWndQLock.LeaveCriticalSection()
        end
      of ?button2
        msgs.msgid=2
        get(msgs,msgs:kMsgID)
        if ~errorcode() then
          trayWndQLock.EnterCriticalSection()
            TrayWndQ.cFrom=msgs.cfrom
            traywndq.cMsg=msgs.cmsg
            traywndq.msgid=msgs.msgid
            add(traywndq,1)
          trayWndQLock.LeaveCriticalSection()
        end
      else
        cycle
      end
    end !case event
  end !accept
  close(msgs)
  close(window)

!This procedure is started when a tray window is double clicked
showmsg procedure(string strMsgID)
window WINDOW('Message Form'),AT(,,185,92),SYSTEM,GRAY,DOUBLE,mdi
       PROMPT('From:'),AT(3,9),USE(?Prompt1)
       ENTRY(@s40),AT(25,9,60,10),USE(msgs:cfrom)
       PROMPT('Message:'),AT(5,25),USE(?Prompt2)
       TEXT,AT(40,26,137,42),USE(msgs:cmsg),VSCROLL
       BUTTON('OK'),AT(45,74,35,14),USE(?OkButton),DEFAULT
       BUTTON('Cancel'),AT(93,74,36,14),USE(?CancelButton)
     END

  code
  Open(msgs,42H)
  if errorcode() then message('open failed: ' & error()); return.
  msgs.msgid=strmsgid
  get(msgs,msgs:kmsgid)
  if errorcode() then
    message('Message not found: ' & strmsgid)
    close(msgs)
    return
  end
  open(window)
  0{prop:text}=0{prop:text} & ' - Thread# ' & thread()
  display()
  accept
    case event()
    of event:accepted
      case field()
      of ?cancelbutton
        post(Event:closewindow)
      of ?okbutton
        update()
        if ~msgs:cmsg or ~msgs:cfrom then
          message('Neither from nor message can be blank.')
          select(?msgs:cfrom)
          cycle
        end
        Put(msgs)
        if errorcode() then
          message('Put error: ' & error())
        end
        post(event:closewindow)
      end !case field
    end !case event
  end !accept loop
  close(window)


